#! /bin/bash

#########################################################################
#########################################################################
#########################################################################
#            À exécuter en mode root dans un terminal
#########################################################################
#########################################################################
#########################################################################



#######################################################################################################
#
# Ce script permet de créer un répertoire partager public pour tous les utilisateurs.
# Il est placé sous /home/public
# Chaque utilisateur y ayant droit doit être ajouté au groupe public
# Chaque utilisateur peut accéder à tout et aussi modifier des fichiers
# L'utilisateur ne peut supprimer que ce qui lui appartient
#
#
# ce script est né de la collaboration depuis la liste ubuntu-fr.lists.ubuntu.com
#
#              Par: Steve Nadeau
# Ayant collaborés: Sébastien Moratinos
#                   Avell Diroll
#                   Jacques Lavignotte
#                   Serge Besson
#
# si j'en oublie, faites moi signe: stevenado@gmail.com
#
#
#######################################################################################################


#########################################################################
#1 Création du répertoire public 
#########################################################################

mkdir /home/public


#########################################################################
#2 Création du groupe public 
#########################################################################

addgroup public

#########################################################################
#3  Modification du propriétaire et groupe 
#########################################################################

chown root:public /home/public/

#########################################################################
#4 Modification des droits 
#########################################################################

chmod 3774 /home/public/

#########################################################################
#5 Ajout du groupe public pour les futurs utilisateurs 
#########################################################################

bak=$(date +%Y%m%d%H%M%S)
mv /etc/adduser.conf /etc/adduser.conf.$bak
sed -e 's/#EXTRA_GROUPS="dialout cdrom floppy audio video plugdev users"/EXTRA_GROUPS="dialout cdrom floppy audio video plugdev users public"/' /etc/adduser.conf.$bak >/etc/adduser.conf

bak=$(date +%Y%m%d%H%M%S)
mv /etc/adduser.conf /etc/adduser.conf.$bak
sed -e 's/#ADD_EXTRA_GROUPS=1/ADD_EXTRA_GROUPS=1/' /etc/adduser.conf.$bak >/etc/adduser.conf

#########################################################################
#6 Ajout du lien symbolique pour les futurs nouveaux utilisateurs
#########################################################################

ln -s /home/public/ /etc/skel/Public

#########################################################################
#7 Ajout des utilisateurs au groupe public 
#########################################################################

for i in $(cat /etc/passwd |grep /bin/bash |grep /home | cut -d: -f1); 
  do 
    usermod -aG public $i; 
  done

#########################################################################
#Les membres du groupe public ont tous les droits dans le répertoire.
#  À l'exception qu'un utilisateur ne peut effacer que les fichiers 
#  qui lui appartiennent
#########################################################################

#########################################################################
#8 Lien symbolique pour les utilisateurs 
#
#On renomme l'ancien dossier Public (celui présent par défaut)
#On applique les droits de l'utilisateur
#########################################################################

for i in $(cat /etc/passwd |grep /bin/bash |grep /home | cut -d: -f1); 
  do 
    echo $i
    cd /home/$i 
    mv /home/$i/Public /home/$i/DefautPublic 
    ln -s /home/public/ /home/$i/Public
    echo chown -v -h $i:$i /home/$i/Public
    chown -v -h $i:$i /home/$i/Public;
  done
  
#########################################################################
#Le répertoire Public de l'utilisateur pointe maintenant 
#vers le repertoire /home/public
#########################################################################




